package de.jottyfan.timetrack.help;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import javax.enterprise.context.SessionScoped;
import javax.inject.Named;

/**
 * 
 * @author henkej
 *
 */
@Named
@SessionScoped
public class ThemeBean implements Serializable
{
	private static final long serialVersionUID = 1L;
	
	private String currentTheme;

	public List<String> getValidThemes(){
		List<String> list = new ArrayList<>();
		list.add("cerulean");
		list.add("cosmo");
		list.add("cyborg");
		list.add("darkly");
		list.add("default");
		list.add("flatly");
		list.add("journal");
		list.add("lumen");
		list.add("other");
		list.add("paper");
		list.add("patternfly");
		list.add("readable");
		list.add("sandstone");
		list.add("simplex");
		list.add("slate");
		list.add("spacelab");
		list.add("superhero");
		list.add("united");
		list.add("yeti");
		return list;
	}
	
	public void setCurrentTheme(String currentTheme)
	{
		this.currentTheme = currentTheme;
	}

	/**
	 * contains current theme for web.xml's theme chooser
	 * 
	 * @return current theme
	 */
	public String getCurrentTheme()
	{
		return currentTheme == null ? "default" : (getValidThemes().contains(currentTheme) ? currentTheme : "default"); 
	}
}
