package de.jottyfan.timetrack.modules;

import java.io.Serializable;

import javax.enterprise.context.SessionScoped;
import javax.inject.Named;

import org.jasypt.util.password.StrongPasswordEncryptor;

/**
 * 
 * @author henkej
 *
 */
@Named
@SessionScoped
public class SessionBean implements Serializable {
	private static final long serialVersionUID = 1L;

	private Integer login;
	private String username;
	private String secret;
	private String forename;
	private String surname;

	public Boolean getHasLogin() {
		return login != null;
	}

	public Boolean getHasNoLogin() {
		return login == null;
	}

	public Integer getLogin() {
		return login;
	}

	public void setLogin(Integer login) {
		this.login = login;
	}

	public String getSecret() {
		StrongPasswordEncryptor spe = new StrongPasswordEncryptor();
		return spe.encryptPassword(secret);
	}

	public boolean checkSecret(String encrypted) {
		StrongPasswordEncryptor spe = new StrongPasswordEncryptor();
		return spe.checkPassword(secret, encrypted);
	}
	
	public void setSecret(String secret) {
		this.secret = secret;
	}

	public String getForename() {
		return forename;
	}

	public void setForename(String forename) {
		this.forename = forename;
	}

	public String getSurname() {
		return surname;
	}

	public void setSurname(String surname) {
		this.surname = surname;
	}

	public String getUsername() {
		return username;
	}

	public void setUsername(String username) {
		this.username = username;
	}
}
