package de.jottyfan.timetrack.modules.contact;

import java.io.Serializable;

import javax.enterprise.context.RequestScoped;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import de.jooqFaces.JooqFacesContext;
import de.jottyfan.timetrack.help.Navigation;
import de.jottyfan.timetrack.help.Pages;
import de.jottyfan.timetrack.modules.ControlInterface;

/**
 * 
 * @author jotty
 * 
 */
@Named
@RequestScoped
public class ContactControl extends Navigation implements ControlInterface, Serializable {
	private static final long serialVersionUID = 1L;

	@Inject
	@Named("contactModel")
	private ContactModel model;

	public String toStart() {
		return navigateTo(Pages.START);
	}

	public String toList() {
		boolean ready = model.init((JooqFacesContext) FacesContext.getCurrentInstance());
		return ready ? navigateTo(Pages.CONTACT_LIST) : toStart();
	}

	public String toItem(ContactBean bean) {
		model.setBean(bean);
		return navigateTo(Pages.CONTACT_ITEM);
	}

	public String toItem() {
		model.setBean(new ContactBean(null));
		return navigateTo(Pages.CONTACT_ITEM);
	}

	public String doAdd() {
		boolean ready = model.add((JooqFacesContext) FacesContext.getCurrentInstance());
		return ready ? toList() : navigateTo(Pages.CONTACT_ITEM);
	}

	public String doUpdate() {
		boolean ready = model.update((JooqFacesContext) FacesContext.getCurrentInstance());
		return ready ? toList() : navigateTo(Pages.CONTACT_ITEM);
	}

	public String doDelete() {
		boolean ready = model.delete((JooqFacesContext) FacesContext.getCurrentInstance());
		return ready ? toList() : navigateTo(Pages.CONTACT_ITEM);
	}
	
	public Integer getAmount() {
		return model.getAmount((JooqFacesContext) FacesContext.getCurrentInstance());
	}
}
